
-- Parametres globaux
gPluginName="KikiTiers";
gDebug = {};

-- Import 
import "Turbine";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.Gameplay";

import "Kiki.Commons.Trace";
import "Kiki.Commons.UTF";
import "Kiki.Commons.Class";
import "Kiki.Commons.Tools";
import "Kiki.Commons.StringUtils";
import "Kiki.Commons.Settings";
import "Kiki.Commons.Onscreen";
import "Kiki.Commons.WinFlash";
import "Kiki.KikiTiers.Languages";
import "Kiki.KikiTiers.WinTiers";

-- Charge les traductions
gLanguage = getClientLanguage();
gLang = getLang(gLanguage); 

-- Joueur
gPlayer = Turbine.Gameplay.LocalPlayer.GetInstance();
gPlayerName = gPlayer:GetName();


-- Usage
Kiki.Commons.Trace(gLang.USAGE);

-- Fenetres

wFlash = Kiki.Commons.WinFlash();
wTiers = WinTiers(gPluginName.."_panel",wFlash);


-- Function de dechargment du plugin
Plugins[gPluginName].Unload = function(self,sender,args)
	wTiers:Unload();
	Kiki.Commons.Trace("unloaded");
end

-- Tracker du mode combat
gPlayer.InCombatChanged = function(sender, args)
	wTiers:CombatMode(gPlayer:IsInCombat());
end


-- commande /seuils XXX val% val% val% val% ....
scCommand = Turbine.ShellCommand();
Turbine.Shell.AddCommand(gLang.COMMAND, scCommand);
function scCommand:GetShortHelp()
    return gLang.USAGE;
end
function scCommand:GetHelp()
    return self:GetShortHelp();
end
function scCommand:Execute(cmd, oargs)
	local args = UtfToRawLower(oargs);
	if #args > 0 then
		if args==gLang.LIST then
			wTiers:DisplayList();
		elseif args==gLang.FLASH then
			wTiers:FlashDisplay();
		elseif args==gLang.FLASHON then
			wTiers:FlashMode(true);
		elseif args==gLang.FLASHOFF then
			wTiers:FlashMode(false);
		else
			local name, values = string.match(args,"([^=]+)=(.*)");
			-- Kiki.Commons.Trace("oargs=".. (oargs or "nil") .." args=".. (args or "nil") .. " name=".. (name or "nil") .. " values=".. (values or "nil") );
			if name ~= nil then
				name = Kiki.Commons.trim(name);
				if name==gLang.FLASH then
					local r,g,b = string.match(values,"(%d+) (%d+) (%d+)");
					if tonumber(b) ~= nil then
						wTiers:FlashColor(tonumber(r) % 101,tonumber(g) % 101,tonumber(b) % 101);
					else
						Kiki.Commons.Trace(gLang.SYNTAX);
					end
				elseif values==nil or #values==0 then
						-- Annulation du tracking du boss....
						wTiers:ClearBoss(name);
				else
					local tiers={};
					-- dfinition des seuils
					for v in string.gmatch(values, "(%d+)") do
						table.insert(tiers,tonumber(v));
					end
					table.sort(tiers);
					-- Ajoute les seuils pour traitement
					wTiers:SetupBoss(name,tiers);
				end
			else
				Kiki.Commons.Trace(gLang.SYNTAX);
			end
		end
	else
		-- toggle la fenetre !
		wTiers:Toggle();
	end
end




-- Retrouve la version du plugin
Kiki.Commons.Trace("loaded (version ".. Plugins[gPluginName]:GetVersion() .. " by Kikiadoc@Sirannon)");












