-- KikiRools Panel


WinTiers = class(Turbine.UI.Window);



function WinTiers:Constructor(profile,flash)
	Turbine.UI.Window.Constructor(self)

	-- Chrono de dpart
	self.startDth = 0;
	self.debugCount = 0;

	-- generic
	self:SetMouseVisible(true);
	self:SetSize(150,16);
	self:SetVisible(false);
	self:SetBackColor(Turbine.UI.Color( 0.3,0.3,0.3));

	-- layout
	local wL;
	
	-- nom du boss
	wL = Turbine.UI.Label();
	wL:SetParent(self);
	wL:SetSize(108,14);
	wL:SetPosition(2,2);
	wL:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
	wL:SetFont(Turbine.UI.Lotro.Font.Verdana12);
	wL:SetText("undefined ");
	wL:SetMouseVisible(false);
	self.boss = wL;
	
	-- % du boss
	wL = Turbine.UI.Label();
	wL:SetParent(self);
	wL:SetSize(38,14);
	wL:SetPosition(110,2);
	wL:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
	wL:SetFont(Turbine.UI.Lotro.Font.Verdana12);
	wL:SetText("--%");
	wL:SetMouseVisible(false);
	self.bossPercent = wL;


		
	-- Recupere les donnes associes
	self.settingsName = profile;
	self.settings = Kiki.Commons.Settings(profile, { top=0; left=0; bosses={}; flashTime=10; version=1; } );
	if self.settings.version == nil then
		self.settings.version = 0;
	end
	-- Conversion des donnes en fonction des versions
	if self.settings.version < 1 then
		-- convert settings from V0 to V1
		Kiki.Commons.Trace("Settings conversion (v0 to v1) started !!!!!");
		-- Difference : boss names index are stored in rawlowercase !
		local v0bosses = self.settings.bosses;
		local v1bosses = {};
		for i,boss in pairs(v0bosses) do
			-- Transforme en lowercase l'index
			v1bosses[UtfToRawLower(boss.name)] = boss;
		end
		self.settings.bosses = v1bosses;
		self.settings.version=1;
		Kiki.Commons.Trace("Settings conversion (v0 to v1) done !!!!!");
	end

	-- Fenetre de flash associe
	self.wFlash = flash;
	-- Parametre du flash
	if self.settings.flashColor == nil then
		self.settings.flashColor = { r=100, g=0, b=0, rgb="FF0000" };
	end
	self:FlashColor(self.settings.flashColor.r,self.settings.flashColor.g,self.settings.flashColor.b);
	
	-- tracking de la position
	self.PositionChanged = function (sender,args)
		self.settings.top = self:GetTop();
		self.settings.left = self:GetLeft();
	end
	
	self.MouseDown = function (sender, args)
		-- Kiki.Commons.Trace("mouseDown:"..args.X..","..args.Y);
		self.wcDRAGGING = true;
		self.wcRelX = args.X;
		self.wcRelY = args.Y;
	end
	
	self.MouseUp = function (sender, args)
		-- Kiki.Commons.Trace("mouseUp:"..args.X..","..args.Y);
		if self.wcDRAGGING then
			self.wcDRAGGING = false;
		end
	end
	
	self.MouseMove = function (sender, args)
		if self.wcDRAGGING == true then
			local scX = Turbine.UI.Display.GetMouseX();
			local scY = Turbine.UI.Display.GetMouseY();
			local pX = scX - self.wcRelX;
			local pY= scY - self.wcRelY;

			if pX < 0 then pX = 0 end
			if pY < 0 then pY = 0 end

			self:SetPosition(pX,pY);
		end
	end
	
	
	
	
	-- Positionne sur l'ecran
	self:SetPosition(self.settings.left,self.settings.top);
	
	
	-- Affichage si besoin
	if self.settings.visible == true then
		self:Show();
	end

end

function WinTiers:Show()
	Kiki.Commons.Onscreen(self);
	self:SetVisible(true);
	self:Activate();
	self.settings.visible=true;
	-- Dans le cas d'un changement de cible....
	gPlayer.TargetChanged  = function(sender, args)
		self:TargetChanged();
	end
	Kiki.Commons.Trace(gLang.ENABLE);
	-- par defaut, on fait comme si la cible avait change....
	self:TargetChanged();
	
end
function WinTiers:Hide()
	self:SetVisible(false);
	self.settings.visible=false;
	-- desactive le tracking
	gPlayer.TargetChanged = nil;
	Kiki.Commons.Trace(gLang.DISABLE);
end

function WinTiers:Toggle()
	if self:IsVisible() then
		self:Hide();
	else
		self:Show();
	end 
end

function WinTiers:Unload()
	self.settings:Save(self.settingsName);
end

-- la cible du joueur a chang
function WinTiers:TargetChanged()
	self.debugCount=self.debugCount+1;
	Kiki.Commons.Trace("targetChanged" .. 	self.debugCount );
	self.tg = gPlayer:GetTarget();
	if self.tg == nil then
		-- il n'y a plus de cible....
		self.boss:SetForeColor(Turbine.UI.Color( 0.2,0.2,0.2));
		self.bossPercent:SetForeColor(Turbine.UI.Color( 0.2,0.2,0.2));
	else
		-- recupere les infos associes au nom du boss
		local desc = self.settings.bosses[UtfToRawLower(self.tg:GetName())];
		if desc ~= nil then
			-- La cible est connue, et doit tre tracke
			self.tracked = desc;
			self.boss:SetForeColor(Turbine.UI.Color( 1,1,1));
			self.bossPercent:SetForeColor(Turbine.UI.Color( 1,1,1));
			self.boss:SetText(self.tg:GetName()..": ");
			-- force le reclacul du ratio et du procahin tier
			self.lastRatio = 101;
			self.nextTier = 101;
			-- Message d'info sur les seuils actifs
			Kiki.Commons.Trace(self:GetLiteral(desc));
			
			
			self.tg.MoraleChanged = function()
				self:MoraleChanged();
			end
			
			self:MoraleChanged();
		else
			-- la cible est inconnue, on l'ignore
			self.boss:SetForeColor(Turbine.UI.Color( 0.2,0.2,0.2));
			self.bossPercent:SetForeColor(Turbine.UI.Color( 0.2,0.2,0.2));
			self.tg = nil;
		end
	end
end

-- mise  jour sur update des infos de la cible
function WinTiers:MoraleChanged()
	if self.tg ~= nil then
		local cur = self.tg:GetMorale();
		local max = self.tg:GetMaxMorale();
		-- truc bizarre... cur = 0 et max != 0 quand on switch la cible, car le moralechanged arrive avant le targetchanged....
		local ratio = 100;
		if max ~= 0 then
			ratio = math.ceil( 100 * (cur / max)) ;
		end
		if self.lastRatio ~= ratio and cur > 0 then
			self.lastRatio = ratio;
			self.bossPercent:SetText(ratio.."%");

			-- test si le ratio est infrieur au niveau de seuil
			if self.nextTier >= ratio then
				-- on vient de dpasser / atteindre le seuil prcdent (=101 si requete de recalcul initiale)
				if self.nextTier < 100 then
					-- Alerte visuelle
					Kiki.Commons.Trace("<rgb=#FF0000>" .. self.tracked.name .. " <= " .. self.nextTier .. "%</rgb>");
					self:StartBlink();
					if self.settings.flashMode == true then
						self.wFlash:Start();
					end
				end
				-- on recalcul le seuil
				self.nextTier = 0;
				for i,v in ipairs(self.tracked.tiers) do
					if v >= ratio then
						break;
					end
					self.nextTier = v;
				end
				-- Il y a un niveau de tier calcul.... ou 0 si tous les seils sont atteints
				-- Kiki.Commons.Trace("lvl="..self.nextTier.." cur="..ratio);
			end
		end 
	end
end

function WinTiers:Update()
	-- Gestion du blink
	if self.startDth > 0 then
		local now = math.floor(Turbine.Engine.GetGameTime()*10);
		if now > self.endDth then
			self:SetWantsUpdates(false);
			self.startDth = 0;
			self:SetBackColor(Turbine.UI.Color( 0.3,0.3,0.3));
		elseif self.lastDth ~= now then
			self.lastDth = now;
			if (now - self.startDth) % 2 == 0 then
				self:SetBackColor(Turbine.UI.Color( 0.5,0,0));
			else
				self:SetBackColor(Turbine.UI.Color( 0.5,0.5,0));
			end
		end
	end
end


function WinTiers:StartBlink()
	local ft = self.settings.flashTime;
	self.startDth = math.floor(Turbine.Engine.GetGameTime()*10);
	self.lastDth = 0; 
	-- par defaut, 1 seconde de flashtime
	self.endDth = self.startDth + (self.settings.flashTime or 10); 
	
	self:SetWantsUpdates(true);	
end



-- Annulation du tracking du boss
function WinTiers:ClearBoss(oname)
	-- vire les blancs
	local name = Kiki.Commons.trim(UtfToRawLower(oname));
	if #name == 0 then
		return;
	end
	local old = self.settings.bosses[name];
	if old ~= nil then
		self.settings.bosses[name]=nil;
		self:TargetChanged();
		Kiki.Commons.Trace(name.." : "..gLang.REMOVED);
	else
		Kiki.Commons.Trace(name.." : "..gLang.UNDEFINED);
	end
end

-- Setup  du tracking du boss
function WinTiers:SetupBoss(oname,tiers)
	-- vire les blancs
	local name = Kiki.Commons.trim(oname);
	if #name == 0 then
		return;
	end
	local desc = { name=name; tiers=tiers; };
	self.settings.bosses[UtfToRawLower(name)] = desc;
	Kiki.Commons.Trace(self:GetLiteral(desc));
	self:TargetChanged();
end

function WinTiers:CombatMode(mode)
	if mode == true then
		-- passage en mode combat: on reset le tracking
		self.lastTracked = nil;
		self:TargetChanged();
	end
end

function WinTiers:GetLiteral(desc)
	if desc.literal ~= nil then
		return desc.literal;
	end
	local str = desc.name .. " [ ";
	for i,v in ipairs(desc.tiers) do
			str = str..v.."% "
	end
	str = str.."]";
	-- mise en "cache"
	desc.literal = str;
	-- retourne le literal
	return str;
end

function WinTiers:DisplayList()
	Kiki.Commons.Trace("======================");
	for k,desc in pairs(self.settings.bosses) do
		Kiki.Commons.Trace(self:GetLiteral(desc));
	end 
	Kiki.Commons.Trace("======================");
end

function WinTiers:FlashMode(mode)
	self.settings.flashMode = mode;
	self:FlashDisplay();
end

function WinTiers:FlashDisplay()
	if self.settings.flashMode == true then
		Kiki.Commons.Trace(gLang.FLASHON.." <rgb=#"..self.settings.flashColor.rgb..">r=".. self.settings.flashColor.r .. " g=".. self.settings.flashColor.g .. " b=" ..self.settings.flashColor.b .."</rgb>");
	else
		Kiki.Commons.Trace(gLang.FLASHOFF);
	end
end

-- Positionne la couleur de flash (r,g,b exprim entre 0 et 100)
function WinTiers:FlashColor(r,g,b)
	self.settings.flashColor = {r= r; g= g ; b= b; rgb= string.format("%02X%02X%02X",math.floor(0.6 + r*2.55),math.floor(0.6 + g*2.55),math.floor(0.6 + b*2.55)) };
	self.wFlash:SetupColor(r / 100 , g / 100 , b / 100);
	self:FlashDisplay();
end

 
